function scrollIfNotVis(el) {
  var h = el.offsetHeight;
  var t = el.offsetTop;
  var p = el;
  while (p = p.offsetParent)
    t += p.offsetTop;
  if (!(t >= window.pageYOffset && (t + h) <= (window.pageYOffset + window.innerHeight))) {
    scrollToElement(el);
  }
}

function scrollToElement(el) {
  var y = 0;
  while (el != null) {
    y += el.offsetTop;
    el = el.offsetParent;
  }
  window.scrollTo(0, y);
}

function scrollToSent(n) {
  scrollToElement(document.getElementsByTagName("snt")[n]);
}

function getTopBottom(element) {
  if (typeof element === "undefined")
    return [0, 0];
  var viewportElement = document.documentElement;
  var box = element.getBoundingClientRect();
  var scrollTop = viewportElement.scrollTop;
  return [box.top - scrollTop, box.bottom - scrollTop];
}

function getSntAt(y) {
  var snts = document.getElementsByTagName("snt");
  var tb = getTopBottom(snts[0]);
  if (tb[0]>y)
    return 0;
  for (var i=0; i<snts.length-1; i++) {
    if (tb[0]<=y && tb[1]>=y)
      return i;
    var b=tb[1];
    tb = getTopBottom(snts[i+1]);
    if (y>b && y<=tb[0])
      return i+1;
  }
  return snts.length-1;
}

function evalJsForAndroid(evalJs_index, jsString) {
  var evalJs_result = "";
  try {
    evalJs_result = ""+eval(jsString);
  } catch (e) {
    console.log(e);
  }
  JavaCallback.processReturnValue(evalJs_index, evalJs_result);
}

function recalculateWidth() {
  var el = document.getElementById('contentRoot');
  el.style.width = window.innerWidth - window.innerWidth/32;
}

function setAllColors(bkc, txc) {
  var all = document.getElementsByTagName("*");
  var b = document.body.getAttribute("avarTB")===null;
  for (var i=0, max=all.length; i < max; i++) {
    var el = all[i];
    if (el.tagName == "SNT" || el.tagName == "HTML")
      continue;
    if (b) {
      var s = el.style.color + ";"+ el.style.backgroundColor;
      if (s.length > 1)
        el.setAttribute("avarTB", s);
    }
    var ocb = el.getAttribute("avarTB");
    if (ocb != null) {
      if (bkc == 0 || txc == 0)
        ocb = ocb.split(";");
      el.style.color = txc == 0 ? ocb[0] : txc;
      el.style.backgroundColor = bkc == 0 ? ocb[1] : bkc;
    } else {
      if (txc.length>0)
        el.style.color = txc;
      else
        el.style.removeProperty("color");
      if (bkc.length>0)
        el.style.backgroundColor = bkc;
      else
        el.style.removeProperty("background-color");
    }
  }
}

